local %args;
/^\-?(\w+)=(.+)$/o and $args{+lc $1}=$2 foreach @ARGV;
defined $args{$_} && $args{$_}!~/[^\w\/\:\-\.\+]/o or die <DATA> foreach qw'in out';
if(defined $args{locale} && lc $args{locale} eq 'on') {use locale}

sub eqi {+lc shift eq lc shift}

sub free_spaces {
	my@p=@_;
	s[\s+][ ]gos and (
		s[^ ][]gos,
		s[ $][]gos
	) foreach @p;
	+@p
}

sub lcs_str {
	my($a, $b)=@_;
	my($m, $n)=(length $a, length $b);
	my(@L, $i, $j);

	for ($i = $m; $i >= 0; $i--) {
		$L[$i] ||= [];
		for ($j=$n; $j >= 0; $j--) {
			$L[$i][$j] = do{
				if($i >= $m || $j >= $n) {
					+0
				} elsif(&eqi(substr($a, $i+1, 1), substr($b, $j+1, 1))) {
					+1+$L[$i+1][$j+1]
				} elsif($L[$i+1][$j]>$L[$i][$j+1]) {
					+$L[$i+1][$j]
				} else {
					+$L[$i][$j+1]
				}
			}
		}
	}

	my(@B, $S, $c);($i, $j)=(0, 0);
	while($L[$i][$j] > 0) {
		if (&eqi($c=substr($a, $i, 1), substr $b, $j, 1)) {
			$S.=$c;
			$i++; $j++; next
		}
		$L[$i+1][$j] >= $L[$i][$j+1] ? $i++ : $j++;
		next unless defined $S;
		push @B, $S;
		$S=undef;
	}

	+ defined $S ? (@B, $S) : @B
}

$join=exists $args{join} ? $args{join} : '(.*?)';

open OUT, '>'.$args{out};
	print OUT +join $join, map quotemeta, lcs_str free_spaces @{+do $args{in}};
close OUT;

+1;

__END__


    Str2Rex v0.98b util - simply converts two strings to RegExp

    This util based on the classic LCS algorithm.

-------------------------------------------------------------------
 Usage:
      perl str2rex.pl -in=in.txt -out=out.txt
      perl str2rex.pl -in=in.txt -out=out.txt -locale=on
      perl str2rex.pl in=in.txt out=out.txt locale=off -join=(.+?)

 Arguments:
	         -in - Input file path.
	        -out - Output file path.
	     -locale - Switches on/off using locale.
	       -join - Use this argument to set variable part of
	               the resulting RegExp. Default value is (.*?)

 Example:

  Meaning, input file contains two strings and
                              have following Perl syntax:

 # file "in.txt"
 #-----------------------------------------------------------------
 # The beginning of input file
 + [<<'-- DELIMETER 1 --', <<'-- DELIMETER 2 --'];

 This!
	is the
     "first
  string!

-- DELIMETER 1 --

  This
    is>
      the "second string

-- DELIMETER 2 --

 # The end of input file
 #-----------------------------------------------------------------

 Then enter at your command line following commands:
 perl str2rex.pl -in=in.txt -out=out.txt

 As result you have something like:
 This(.*?)\ is(.*?)\ the\ \"(.*?)s(.*?)\ string

-------------------------------------------------------------------
                                 Shatrow Aleksey <cdch@yandex.ru>
                                            Krasnodar, 28.03.2005
-------------------------------------------------------------------
